import { Controller, Get, Render } from '@nestjs/common';

/**
 * @Render 装饰器 返回值 {name: xxx} 关联的是静态资源的文件夹的名称,
 * webpack构建单页面输出的 js / css资源的打包到public下的静态资源名称
 */

@Controller()
export class BaseController {
  @Get('/')
  @Render('page/home/index')
  async homeViewModel() {
    return { name: 'home' };
  }

  @Get('/signup')
  @Render('page/signup/index')
  async signupViewModel() {
    return { name: 'signup' };
  }

  @Get('/login')
  @Render('page/login/index')
  async loginViewModel() {
    return { name: 'login' };
  }
}
