import {
  CallHandler,
  ExecutionContext,
  Inject,
  Injectable,
  NestInterceptor,
} from '@nestjs/common';
import { Request, Response } from 'express';
import { Observable, tap } from 'rxjs';
import cookie = require('cookie');
import { SECURE_SIGN } from 'src/config/constant';
import { AuthService } from 'src/service/auth.service';

@Injectable()
export class AuthInterceptor implements NestInterceptor {

  intercept(
    context: ExecutionContext,
    next: CallHandler<any>,
  ): Observable<any> | Promise<Observable<any>> {
    return next.handle().pipe(
      tap(() => {
        const host = context.switchToHttp();
        const request = host.getRequest<Request>();
        // 获取请求头
        const cookies = cookie.parse(request.headers.cookie || '');

        //TODO 缺少 token，如果访问的是接口需要鉴权重定向等登录
        if (cookies[SECURE_SIGN]) return;

        //TODO 如果有 token, decodeSign，判断 token 是否合法，
        // const payload =authService
        // 响应头续签
        const response = host.getResponse<Response>();
        console.log(request.headers.cookie);
        // const token = 'token';

        // response.cookie(SECURE_SIGN, token, {
        //   httpOnly: true,
        //   sameSite: 'strict',
        //   // secure: process.env.NODE_ENV === 'prod', // https 传输
        // });

        return response;
      }),
    );
  }
}
