import axios from 'axios';
import { PREFIX } from '../../config/router';

const CancelToken = axios.CancelToken;
export const sourceCommon = CancelToken.source();

const axiosCommon = axios.create({
  timeout: 6000 * 1000,
  cancelToken: sourceCommon.token,
  baseURL: PREFIX.startsWith('/') ? PREFIX : '/' + PREFIX,
});

// 请求拦截
axiosCommon.interceptors.request.use(
  (config) => {
    //TODO 一些拦截操作 here
    return config;
  },
  (error) => {
    //TODO 一些提示...here
    return Promise.reject(error);
  },
);

// 响应拦截
axiosCommon.interceptors.response.use(
  (response) => {
    const { code } = response.data;
    switch (code) {
      case 1000:
        if (window.location.pathname != '/login') {
          window.location.href = `/login`;
        }
        // message.warn('即将回到登录页');
        // setTimeout(() => {

        // }, 3000);
        break;
      default:
        break;
    }
    return response.data;
  },
  (err) => Promise.reject(err),
);

export { axiosCommon };
